<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\DataTables\Pracovisko\PocetKontrolAObratuPodlaSubjektuFakturacie;

use Illuminate\Contracts\Support\Arrayable;
use Illuminate\Contracts\Support\Jsonable;
use InvalidArgumentException;
use JsonSerializable;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaObratuASubjektuFakturacie;
use Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\DataTables\DataTableRowContract;

/**
 * Class PocetKontrolAObratuPodlaSubjektuFakturacieDataTableRow
 *
 * @package Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\DataTables\Pracovisko\PocetKontrolAObratuPodlaSubjektuFakturacie
 */
final class PocetKontrolAObratuPodlaSubjektuFakturacieDataTableRow implements DataTableRowContract, Arrayable, Jsonable, JsonSerializable
{
    /**
     * @var int
     */
    private int $spolu = 0;

    /**
     * @var float
     */
    private float $obrat = 0;

    /**
     * @var string
     */
    private string $nazovSubjektu;

    /**
     * @param string $nazovSubjektu
     */
    public function __construct(string $nazovSubjektu)
    {
        $this->nazovSubjektu = $nazovSubjektu;
    }

    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaObratuASubjektuFakturacie $pocetKontrolPodlaObratuASubjektuFakturacie
     *
     * @return $this
     */
    public function add(PocetKontrolPodlaObratuASubjektuFakturacie $pocetKontrolPodlaObratuASubjektuFakturacie): self
    {
        if (0 !== substr_compare($this->nazovSubjektu, $pocetKontrolPodlaObratuASubjektuFakturacie->nazovSubjektu(), 0, null, false)) {
            throw new InvalidArgumentException(sprintf(
                'Ocakava sa nazov subjektu %s, vstupny atribut obsahuje nazov subjektu %s',
                $this->nazovSubjektu,
                $pocetKontrolPodlaObratuASubjektuFakturacie->nazovSubjektu()
            ));
        }

        $this->spolu += $pocetKontrolPodlaObratuASubjektuFakturacie->pocet();
        $this->obrat += $pocetKontrolPodlaObratuASubjektuFakturacie->obrat();

        return $this;
    }

    /**
     * @return string
     */
    public function nazovSubjektu(): string
    {
        return $this->nazovSubjektu;
    }

    /**
     * @param int $options
     *
     * @return string
     */
    public function toJson($options = 0): string
    {
        return json_encode($this->toArray(), $options);
    }

    /**
     * @return array
     */
    public function toArray(): array
    {
        return [
            'label' => $this->nazovSubjektu,
            'data' => [
                'spolu' => $this->spolu,
                'obrat' => $this->obrat,
            ],
        ];
    }

    /**
     * @return array
     */
    public function jsonSerialize(): array
    {
        return $this->toArray();
    }
}
